//+------------------------------------------------------------------+
//|                                                      Closeby.mq4 |
//|                                         Copyright  2010, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
//   

#property copyright "Copyright  2010, Kharko"
#property link      ""
#property show_inputs

extern int Magic=0;// 0 -       Magic
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int Error,TicketBuy,TicketSell,Num.Para=1;
   double ProfitBuy,ProfitSell;
   double ProfitBuy1,ProfitSell1;
   string Para[];
//----
   ArrayResize(Para,Num.Para);
   if(OrdersTotal()>0)
   {
      for( int i=0; i<OrdersTotal(); i++) 
      {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
         bool Record=true;
         for( int j=0; j<Num.Para; j++) 
         {
            if(OrderSymbol()==Para[j])
            {
               Record=false;
               break;
            }
         }      
         if(Record)
         {
            Para[Num.Para-1]=OrderSymbol();  
            Num.Para++;
            ArrayResize(Para,Num.Para);
         }
      }
//---
      for( i=0;i<Num.Para;i++)
      {
         TicketBuy=0;
         TicketSell=0;
         ProfitBuy=-AccountBalance();
         ProfitSell=-AccountBalance();
         ProfitBuy1=-AccountBalance();
         ProfitSell1=-AccountBalance();
         RefreshRates();
         for( j=0; j<OrdersTotal(); j++) 
         {
            if(!OrderSelect(j,SELECT_BY_POS,MODE_TRADES)) 
               continue;
            if(Magic==0)
            {
               if(OrderSymbol()!=Para[i]) 
                  continue;
            }
            else
            {
               if(OrderSymbol()!=Para[i] || !(OrderMagicNumber()==Magic || OrderMagicNumber()==0)) continue;
            }
            if(OrderType()==OP_BUY && ProfitBuy<OrderProfit())
            {  
               TicketBuy=OrderTicket();
               ProfitBuy=OrderProfit();
            }
            if(OrderType()==OP_SELL && ProfitSell<OrderProfit())
            {
               TicketSell=OrderTicket();
               ProfitSell=OrderProfit();
            }
         }
//---
         if(TicketBuy>0 && TicketSell>0)
         {
            if(!IsTesting() && (MarketInfo(OrderSymbol(),MODE_TRADEALLOWED) !=1  || IsTradeContextBusy())) 
            {
               Print("Close order ",OrderSymbol(),"    !!!");
               i=-1;
               Sleep(5000);
               RefreshRates();
               continue;
            }
            OrderCloseBy(TicketBuy,TicketSell,CLR_NONE);
            Error=GetLastError();
            if(Error>1)
               Print("Error CLOSE BY order : ",Error);
            else 
            {
               RefreshRates();
               i=-1;
            }
         }
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+